#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Naming Computer
#------------------------------------------------------------------------------
# Class grouping methods to compute names and URI for semantic nets (and their 
# attributes)
#==============================================================================

from rdflib import URIRef


#==============================================================================
# Naming Parameter
#==============================================================================

# Property Naming Variants
PROPERTY_NAMING_0 = ''
PROPERTY_NAMING_1 = 'ing'
PROPERTY_NAMING_2 = '-by'
PROPERTY_NAMING_3 = '-of'


#==============================================================================
# Method to compute naming
#==============================================================================

def define_composite_naming_1(net_1, net_2, net_3, 
                              property_naming=PROPERTY_NAMING_0):
    
    name_1 = f'{net_1.naming}'
    name_2 = f'{net_2.naming}{property_naming}'
    name_3 = f'{net_3.naming}'
    
    return f'{name_1}_{name_2}_{name_3}'
    