#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Atom Property
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import PropertyNet


#==============================================================================
# Net Class
#==============================================================================

class AtomPropertyNet(PropertyNet):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'atomProperty'
        self.type_id = 'Atom_Property_Net'
        self.type_uri = f'net:{self.type_id}'
        
        # -- Net Attributes
        self._core_role = None
        self._target_argument_node = []
        self._property_type = None
        #self._property_name = None
        self._property_name01 = None
        self._property_name10 = None
        self._property_name12 = None

        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def core_role(self):
        self._core_role = super().get_attribute_value(core_role=self._core_role)
        return self._core_role
    
    @core_role.setter
    def core_role(self, new_value):
        self._core_role = self.set_attribute_value(self._core_role, new_value)
        
        
    @property
    def target_argument_node(self):
        self._target_argument_node = super().get_attribute_value(target_argument_node=self._target_argument_node)
        return self._target_argument_node
    
    @target_argument_node.setter
    def target_argument_node(self, new_value):
        self._target_argument_node = self.set_attribute_value(self._target_argument_node, new_value)

        
    @property
    def property_type(self):
        self._property_type = super().get_attribute_value(property_type=self._property_type)
        return self._property_type
    
    @property_type.setter
    def property_type(self, new_value):
        self._property_type = self.set_attribute_value(self._property_type, new_value)

        
    @property
    def property_name01(self):
        self._property_name01 = super().get_attribute_value(property_name01=self._property_name01)
        return self._property_name01
    
    @property_name01.setter
    def property_name01(self, new_value):
        self._property_name01 = self.set_attribute_value(self._property_name01, new_value)
        
        
    @property
    def property_name10(self):
        self._property_name10 = super().get_attribute_value(property_name10=self._property_name10)
        return self._property_name10
    
    @property_name10.setter
    def property_name10(self, new_value):
        self._property_name10 = self.set_attribute_value(self._property_name10, new_value)

        
    @property
    def property_name12(self):
        self._property_name12 = super().get_attribute_value(property_name12=self._property_name12)
        return self._property_name12
    
    @property_name12.setter
    def property_name12(self, new_value):
        self._property_name12 = self.set_attribute_value(self._property_name12, new_value)
