#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Class Net
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import Net


#==============================================================================
# Net Class
#==============================================================================

class ClassNet(Net):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'class'
        self.type_id = 'Class_Net'
        self.type_uri = f'net:{self.type_id}'
        
        # -- Net Attributes
        self._class_name = None
  
        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def class_name(self):
        self._class_name = super().get_attribute_value(class_name=self._class_name)
        return self._class_name
    
    @class_name.setter
    def class_name(self, new_value):
        self._class_name = self.set_attribute_value(self._class_name, new_value)
