#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Composite Class Net
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import ClassNet


#==============================================================================
# Net Class
#==============================================================================

class CompositeClassNet(ClassNet):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'compositeClass'
        self.type_id = 'Composite_Class_Net'
        self.type_uri = f'net:{self.type_id}'
        
        # -- Net Attributes
        self._mother_class_net = None
        self._restriction = []
        self._restriction01 = []
        
        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def mother_class_net(self):
        self._mother_class_net = super().get_attribute_value(mother_class_net=self._mother_class_net)
        return self._mother_class_net
    
    @mother_class_net.setter
    def mother_class_net(self, new_value):
        self._mother_class_net = self.set_attribute_value(self._mother_class_net, new_value)

        
    @property
    def restriction(self):
        self._restriction = super().get_attribute_value(restriction=self._restriction)
        return self._restriction
    
    @restriction.setter
    def restriction(self, new_value):
        self._restriction = self.set_attribute_value(self._restriction, new_value)

        
    @property
    def restriction01(self):
        self._restriction01 = super().get_attribute_value(restriction01=self._restriction01)
        return self._restriction01
    
    @restriction01.setter
    def restriction01(self, new_value):
        self._restriction01 = self.set_attribute_value(self._restriction01, new_value)
