#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Individual Net
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import Net


#==============================================================================
# Net Class
#==============================================================================

class IndividualNet(Net):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'individual'
        self.type_id = 'Individual_Net'
        self.type_uri = f'net:{self.type_id}'
        
        # -- Net Attributes
        self._base_class_name = None
        self._mother_class_net = []
        self._individual_label = None
  
        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def base_class_name(self):
        self._base_class_name = super().get_attribute_value(base_class_name=self._base_class_name)
        return self._base_class_name
    
    @base_class_name.setter
    def base_class_name(self, new_value):
        self._base_class_name = self.set_attribute_value(self._base_class_name, new_value)

        
    @property
    def mother_class_net(self):
        self._mother_class_net = super().get_attribute_value(mother_class_net=self._mother_class_net)
        return self._mother_class_net
    
    @mother_class_net.setter
    def mother_class_net(self, new_value):
        self._mother_class_net = self.set_attribute_value(self._mother_class_net, new_value)

        
    @property
    def individual_label(self):
        self._individual_label = super().get_attribute_value(individual_label=self._individual_label)
        return self._individual_label
    
    @individual_label.setter
    def individual_label(self, new_value):
        self._individual_label = self.set_attribute_value(self._individual_label, new_value)
