#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Phenomena Net
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import Net


#==============================================================================
# Net Class
#==============================================================================

class PhenomenaNet(Net):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'phenomena'
        self.type_id = 'Phenomena_Net'
        self.type_uri = f'net:{self.type_id}'
        
        # -- Net Attributes
        self._phenomena_type = None
        self._phenomena_ref = None
  
        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def phenomena_type(self):
        self._phenomena_type = super().get_attribute_value(phenomena_type=self._phenomena_type)
        return self._phenomena_type
    
    @phenomena_type.setter
    def phenomena_type(self, new_value):
        self._phenomena_type = self.set_attribute_value(self._phenomena_type, new_value)

        
    @property
    def phenomena_ref(self):
        self._phenomena_ref = super().get_attribute_value(phenomena_ref=self._phenomena_ref)
        return self._phenomena_ref
    
    @phenomena_ref.setter
    def phenomena_ref(self, new_value):
        self._phenomena_ref = self.set_attribute_value(self._phenomena_ref, new_value)
