#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Property Net
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import Net


#==============================================================================
# Net Class
#==============================================================================

class PropertyNet(Net):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'property'
        self.type_id = 'Property_Net'
        self.type_uri = f'net:{self.type_id}'
        
        # -- Net Attributes
        self._property_name = None
        
        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def property_name(self):
        self._property_name = super().get_attribute_value(property_name=self._property_name)
        return self._property_name
    
    @property_name.setter
    def property_name(self, new_value):
        self._property_name = self.set_attribute_value(self._property_name, new_value)
