#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Restriction Net
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import Net


#==============================================================================
# Net Class
#==============================================================================

class RestrictionNet(Net):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'restriction'
        self.type_id = 'Restriction_Net'
        self.type_uri = f'net:{self.type_id}'        
        
        # -- Net Attributes
        self._target_node = []
        self._restriction_property = None
        self._restriction_net_value = None
 
        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def target_node(self):
        self._target_node = super().get_attribute_value(target_node=self._target_node)
        return self._target_node
    
    @target_node.setter
    def target_node(self, new_value):
        self._target_node = self.set_attribute_value(self._target_node, new_value)

        
    @property
    def restriction_property(self):
        self._restriction_property = self.get_attribute_value(restriction_property=self._restriction_property)
        return self._restriction_property
    
    @restriction_property.setter
    def restriction_property(self, new_value):
        self._restriction_property = self.set_attribute_value(self._restriction_property, new_value)

        
    @property
    def restriction_net_value(self):
        self._restriction_net_value = super().get_attribute_value(restriction_net_value=self._restriction_net_value)
        return self._restriction_net_value
    
    @restriction_net_value.setter
    def restriction_net_value(self, new_value):
        self._restriction_net_value = self.set_attribute_value(self._restriction_net_value, new_value)
