#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Value Net
#------------------------------------------------------------------------------
# Class to handle semantic nets 
#==============================================================================

from febTransduction.net import Net


#==============================================================================
# Net Class
#==============================================================================

class ValueNet(Net):
    """ Class to handle semantic net.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, support_graph, uri=None):

        # -- Parent init
        super().__init__(support_graph, uri)
        
        # -- Net Type
        self.type_name = 'value'
        self.type_id = 'Value_Net'
        self.type_uri = f'net:{self.type_id}'
        
        # -- Net Attributes
        self._value_label = None
  
        
    #--------------------------------------------------------------------------
    # Accessors for Net Attributes
    #--------------------------------------------------------------------------
        
    @property
    def value_label(self):
        self._value_label = super().get_attribute_value(value_label=self._value_label)
        return self._value_label
    
    @value_label.setter
    def value_label(self, new_value):
        self._value_label = self.set_attribute_value(self._value_label, new_value)
