#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Property Net Query Builder
#------------------------------------------------------------------------------
# Class to generate SPARQL query parts related to semantic nets 
#==============================================================================

#==============================================================================
# Importing required modules
#==============================================================================

from .net import Net


#==============================================================================
# Net Class
#==============================================================================

class PropertyNet(Net):
    """ Class to generate SPARQL query parts related to semantic nets.
    """
    
    #--------------------------------------------------------------------------
    # Constructor(s)
    #--------------------------------------------------------------------------
           
    def __init__(self, num='', signature=False):
        
        # -- Net Signature
        if not signature:
            self.type_name = 'property'
            self.type_id = 'Property_Net'
            self.id = f'?{self.type_name}Net{num}'
            self.type_uri = f'net:{self.type_id}'
        
        # -- Parent init
        super().__init__(signature=True)
        
        # -- Net Attributes
        self.property_name = f'{self.id}PropertyName'
        
        self.predicate_table.update({
            'property_name': 'hasPropertyName'
            })