#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: Query Builders
#------------------------------------------------------------------------------
# Module grouping query part builder for different element classes (net, node, 
# ...)
#==============================================================================

#==============================================================================
# Importing required modules
#==============================================================================

from .element.net import Net
from .element.class_net import ClassNet
from .element.atom_class_net import AtomClassNet
from .element.composite_class_net import CompositeClassNet
from .element.individual_net import IndividualNet
from .element.property_net import PropertyNet
from .element.atom_property_net import AtomPropertyNet
from .element.composite_property_net import CompositePropertyNet
from .element.value_net import ValueNet
from .element.phenomena_net import PhenomenaNet
from .element.restriction_net import RestrictionNet
from .element.logical_set_net import LogicalSetNet


#==============================================================================
# Net Builder(s)
#==============================================================================

# -- Class Net
class_net = ClassNet()
class_net_0 = ClassNet(0)
class_net_1 = ClassNet(1)
class_net_2 = ClassNet(2)
class_net_3 = ClassNet(3)

# -- Atom Class Net
atom_class_net = AtomClassNet()
atom_class_net_0 = AtomClassNet(0)
atom_class_net_1 = AtomClassNet(1)
atom_class_net_2 = AtomClassNet(2)

# -- Composite Class Net
composite_class_net = CompositeClassNet()

# --  Individual Net
individual_net = IndividualNet()

# -- Property Net
property_net = PropertyNet()

# --  Atom Property Net
atom_property_net = AtomPropertyNet()

# --  Composite Property Net
composite_property_net = CompositePropertyNet()

# --  Value Net
value_net = ValueNet()

# -- Phenomena Net
phenomena_net = PhenomenaNet()

# -- Restriction Net
restriction_net = RestrictionNet()

# -- Logical Set Net
logical_set_net = LogicalSetNet()


#==============================================================================
# AMR Structure Builder(s)
#==============================================================================

# TODO