#!/usr/bin/python3.10
# -*-coding:Utf-8 -*

#==============================================================================
# TENET: AMR CTR at 'Data Preprocessing' level
#------------------------------------------------------------------------------
# Module grouping compositional transduction rule_sets (CTR) for the analysis of 
# AMR structures, at 'Data Preprocessing' level
#==============================================================================

#==============================================================================
# CTR Set (CTR as Sparql querries)
#==============================================================================

rule_set = {}


# ---------------------------------------------
# Fix some bugs with named entities
# ---------------------------------------------

rule_set['fix-amr-bug-about-system-solar-planet'] = {
    'label': "fix-amr-bug-about-system-solar-planet",
    'comment': "Fix AMR bug about planet named system solar",
    'construction': """
        # -- New concept
        ?newC a ns3:NamedEntity ;
            rdfs:label ?newLabel.
        ?solarSystem a ?newC.
        
        # -- Tracing original concept as LinkedData and bug 
        ?c rdfs:subClassOf amr:AMR_Linked_Data.
        ?c rdfs:comment 'bug'.
    """,
    'clause': """
        # -- Identify bug about planet named system solar
        ?c a ns3:NamedEntity.
        FILTER ( CONTAINS(str(?c), str(ns4:planet)) ).
        ?solarSystem a ?c ;
            rdfs:label 'Solar System'.
    """,
    'binding':"""
        # -- New concept
        BIND (str('system') AS ?newLabel).
        BIND (CONCAT(str(ns4:), ?newLabel) AS ?n1).
        BIND (uri(?n1) AS ?newC).
    """
    }

